using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Sirenix.OdinInspector;
using KairoEngine.UI.Encyclopedia;

namespace KairoEngine.Grids
{
    public class PlacedObjectEncyclopediaCategory : EncyclopediaCategory
    {
        public List<PlacedObjecEncyclopediaCategoryArticle> articles = new List<PlacedObjecEncyclopediaCategoryArticle>();

        private List<EncyclopediaArticle> data = new List<EncyclopediaArticle>();

        [System.Serializable]
        public class PlacedObjecEncyclopediaCategoryArticle
        {
            [HorizontalGroup("Line", 0.015f), HideLabel] public bool unlocked = true;
            [HorizontalGroup("Line", 0.985f), HideLabel] public PlacedObjectType article;    
        }

        public override List<EncyclopediaArticle> GetArticles()
        {
            if(data.Count == 0) UpdateArticles();
            return data;
        }

        public override void UpdateArticles()
        {
            data = new List<EncyclopediaArticle>();
            foreach (PlacedObjecEncyclopediaCategoryArticle item in articles) 
            {
                var article = item.article.GetArticle();
                article.id = id + "_" + article.id;
                article.unlocked = item.unlocked;
                data.Add(article);
            }
        }
    }
}
